#include <stdio.h>
#include <stdlib.h>
// Cette bibliothque est charge pour les fonctions isdigit et isspace
#include <ctype.h>
#include "table.hpp"
#include "arbre.hpp"
#include "an_lex.hpp"

lexliste cons(boite a, lexliste l) {
  lexliste temp = new lexeme;
  (temp -> elt) = a;
  (temp -> succ) = l;
  return(temp);
};

void affiche_boite(boite b) {
  switch (b.g) {
    case op :
         printf("%c ", b.operateur);
         break;
    case cste :
         printf("%d ", b.val);
         break;
    case finl :
         putchar('\n');
         break;
    case ident :
         printf("%s ", tabl_ident.cases[b.ref].nom);
         break;
    case err :
         printf("Erreur ");
         break;
  };
};

void affiche_liste(lexliste l) {
  if (l != NULL) {
	 affiche_boite(l -> elt);
	 affiche_liste(l -> succ);
  };
};

int isop(char c) {
  switch (c) {
    case '+' : ;
    case '-' : ;
    case '*' : ;
    case '/' : ;
    case '=' : ;
    case '(' : ;
    case ')' : return(1);
    default  : return(0);
  };
};

int extract_cste(char *texte, int &i) {
  int temp = 0;

  while (isdigit(texte[i])) {
    temp = 10*temp + texte[i] - '0';
    i++;
  };
  return(temp);
};

void extract_ident(char *texte, int &i, char result[20]) {
  int j = 0;

  while (isalpha(texte[i]) && !isop(texte[i])) {
    if (j < 20) result[j] = texte[i];
    i++; j++;
  };

  result[j] = '\0';
};

lexliste an_lex(char *texte, int i) {
  int temp;
  boite tete;
  char name[20];

  if ((texte[i] == '\n') || (texte[i] == '\0')) {
    tete.g = finl;
    return(cons(tete, NULL));
  }
  else {
    if (isop(texte[i])) {
      tete.g = op; tete.operateur = texte[i];
      return(cons(tete, an_lex(texte, i+1)));
    }
    else {
      if (isdigit(texte[i])) {
        temp = extract_cste(texte, i);
        tete.g = cste; tete.val = temp;
        return(cons(tete, an_lex(texte, i)));
      }
      else {
        if (isalpha(texte[i])) {
          tete.g = ident;
			 extract_ident(texte, i, name);
			 tete.ref = maj(tabl_ident, name);
          return(cons(tete, an_lex(texte, i)));
        }
        else {
          if (isspace(texte[i]))
            return(an_lex(texte, i+1));
          else {
            tete.g = err;
            erreur = 1;
            return(cons(tete, an_lex(texte, i+1)));
          };
        };
      };
    };
  };
};
