#include <stdlib.h>
#include <stdio.h>
#include "table.hpp"
#include "arbre.hpp"
#include "an_lex.hpp"
#include "an_syn.hpp"

lexliste lexemes;
int erreur;
table tabl_ident;
arbre synt_tree;

void traite_erreur() {
  switch (erreur) {
    case 2 :
         printf("Constante ou identificateur attendu.\n");
         break;
    case 3 : 
         printf(") attendue.\n");
         break;
    case 4 : 
         printf("Fin de ligne attendue.\n");
         break;
    case 5 : 
         printf("Identificateur attendu.\n");
         break;
    case 6 : 
         printf("Signe = attendu.\n");
         break;
    default :
         printf("Erreur non prvue.\n");
         break;
  };
};

void main (int argc, char *argv[]) {
  FILE *fichier;
  char expr[255];
  char *nom_fic;

  if (argc == 1) {
    printf("Nom de fichier manquant en paramtre de ligne de commande.\n");
    exit(0);
  }
  else
     nom_fic = argv[1];

  printf("Fichier : %s\n\n", nom_fic);
  if ((fichier = fopen(nom_fic, "r")) == NULL) {
    printf("Fichier de test introuvable. Sortie du programme.\n");
    exit(0);
  };

  init(tabl_ident);

  while (!feof(fichier)) {
    fgets(expr, 255, fichier);

    erreur = 0;
	 synt_tree = NULL;
    lexemes = an_lex(expr, 0);
    affiche_liste(lexemes);

    if (erreur)
      printf("Caractre non attendu dans l'expression.\n");
    else {
      if (an_syn()) {
        printf("L'expression est correcte et vaut : ");
        printf("%d\n", eval_arbre(synt_tree));
//		  affiche_arbre(synt_tree); printf("\n");
      }
      else {
        printf("L'expression est incorrecte  partir de : ");
        affiche_liste(lexemes);
        traite_erreur();
      };
    };
//    affiche_table(tabl_ident);
  };
  fclose(fichier);
  affiche_table(tabl_ident);
};
