#include <stddef.h>
#include "table.hpp"
#include "arbre.hpp"

arbre enracine(arbre fg, boite x, arbre fd) {
  arbre result = new noeud;
  (result -> racine) = x;
  (result -> filsg) = fg;
  (result -> filsd) = fd;
  return(result);
};

arbre cree_noeud(boite x) {
  return(enracine(NULL, x, NULL));
};

void affiche_arbre(arbre a) {
  if (a != NULL) {
    affiche_arbre(a -> filsg);
    affiche_boite(a -> racine);
    affiche_arbre(a -> filsd);
  };
};

int eval_arbre(arbre a) {
  boite temp;
  int calcul;

  if (a != NULL) {
    temp = a -> racine;
    switch (temp.g) {
      case op :
        switch (temp.operateur) {
          case '+' :
            return(eval_arbre(a -> filsg) + eval_arbre(a -> filsd));
          case '-' :
            return(eval_arbre(a -> filsg) - eval_arbre(a -> filsd));
          case '*' :
            return(eval_arbre(a -> filsg) * eval_arbre(a -> filsd));
          case '/' :
            return(eval_arbre(a -> filsg) / eval_arbre(a -> filsd));
          case '=' :
            calcul = eval_arbre(a -> filsd);
            set_val(tabl_ident,
                    ((a -> filsg) -> racine).ref,
                    calcul);
            return(calcul);
          };
      case ident :
        return(get_val(tabl_ident, temp.ref));
      case cste :
        return(temp.val);
    };
  };
  return(0);
};
