#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "table.hpp"

#define size_symbole 22

int init(table &t) {
  t.taille = 20;
  t.libre = 0;
  t.cases = (symbole*)calloc(20, sizeof(symbole));
  return(t.cases != NULL);
};

int get_ref(table t, char *s) {
  int i;
  for (i = 0; i < t.libre; i++)
     if (!stricmp(t.cases[i].nom, s)) return(i);
  return(-1);
};

int get_val(table t, int ref) {
   return(t.cases[ref].valeur);
};

int set_val(table &t, int ref, int val) {
  if (ref < t.libre) {
    t.cases[ref].valeur = val;
    return(1);
  };
  return(0);
};

int ajout(table &t, char symb[20]) {
  if (t.libre < t.taille) {
    strcpy(t.cases[t.libre++].nom, symb);
    return(1);
  }
  else {
    t.taille += 10;
    t.cases = (symbole*)realloc(t.cases, t.taille*sizeof(symbole));
    if (t.cases != NULL) {
		strcpy(t.cases[t.libre].nom, symb);
		t.cases[t.libre++].valeur = 0;
      return(1);
    };
    return(0);
  };
};

int maj(table &t, char *s) {
  int temp = get_ref(t, s);

  if (temp == -1) {
    ajout(t, s);
    temp = t.libre - 1;
  };

  return(temp);
};

void affiche_table(table t) {
  int j;
  for (j = 0; j < t.libre; j++)
     printf("%s = %d\n", t.cases[j].nom, t.cases[j].valeur);
};
